
local Globals = {}

Globals.checked = false;
Globals.mod_plr = {};

local wida_height_ratio = SCREEN_HEIGHT/480
local wida_width_ratio = SCREEN_WIDTH/640
local wida_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640

local function Plr(pn)
	return Globals['P'..pn]
end

local wida_screenaft = --To help replicate nITG behavior, I'm using Kid's screen AFT
  Def.ActorFrameTexture{
    InitCommand= function(self)

    self:SetWidth(SCREEN_WIDTH);
    self:SetHeight(SCREEN_HEIGHT);
    self:EnableDepthBuffer( true );
    self:EnableAlphaBuffer( true );
    self:EnableFloat( false );
    self:EnablePreserveTexture( false );
    self:visible(true);
    self:Create();
    screenAft=self

    wida_aft_height_ratio = SCREEN_HEIGHT/screenAft:GetTexture():GetTextureHeight()
    wida_aft_width_ratio = SCREEN_WIDTH/screenAft:GetTexture():GetTextureWidth()

    end,
    --BACKINGQUAD
    Def.Quad{
        OnCommand= function(self) self:Center():zoomto(SCREEN_WIDTH,SCREEN_HEIGHT):diffuse(0,0,0,1) end,
    },
	
  }
  
  wida_accessible = {}

--Let's add to the AFT to replicate our screen. -Kid
local thingstoproxy = {'SongBackground','Underlay','PlayerP1','PlayerP2','Overlay','LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','SongMeterDisplayP1', 'SongMeterDisplayP2', 'StepsDisplayP1', 'StepsDisplayP2', 'StageDisplay', 'SongTitle'}


d3d = false


if not string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'opengl')
or string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'd3d')
and string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'opengl') 
and string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'd3d') < 
string.find(string.lower(PREFSMAN:GetPreference('VideoRenderers')), 'opengl') then
	d3d = true
end

local addproxy = function(actor, name)
	local thing = SCREENMAN:GetTopScreen():GetChild(name)
	if thing and thing:GetVisible() and thing:GetDiffuseAlpha() ~= 0 then actor:SetTarget(thing) thing:visible(false) end
end

if not d3d then
	for i,v in pairs(thingstoproxy) do
		wida_screenaft[#wida_screenaft+1] =
		Def.ActorProxy{
			ProxyStartMessageCommand= function(self)
				addproxy(self, v)
				table.insert(wida_accessible,self)
			end,
		}
	end
end




local curaction = 1
local mod_actions = {
	{1,'ProxyStart'},
	{1,function() Trace('hahahaha, ronaldinho soccer!!!') end},
	
	
	
	{162,'BumpLeft'},
	{162,'ShakeScreen'},
	{165,'ShakeScreenLong1'},
	
	{170,'BumpRight'},
	{170,'ShakeScreen'},
	{173,'ShakeScreenLong2'},
	
	{178,'BumpLeft'},
	{178,'ShakeScreen'},
	{181,'ShakeScreenLong1'},
	
	{186,'ShakePlayersShort'},
	
	{191,'ShakePlayersShort'},
	{192,'ShakePlayersShort'},
	{193,'ShakePlayersShort'},
	
	{32+162,'BumpRight'},
	{32+162,'ShakeScreen'},
	{32+165,'ShakeScreenLong2'},
	
	{32+170,'ShakePlayersShort'},
	{32+173,'ShakeScreenLong1'},
	
	{32+178,'BumpRight'},
	{32+178,'ShakeScreen'},
	{32+181,'ShakeScreenLong2'},
	
	{218,'Wew'},
	{221,'ShakeScreenLong3'},
	
}

return Def.ActorFrame{
	Name= "xtl_actor_d",
	Def.Actor{ OnCommand= function(s) mod_firstSeenBeat = GAMESTATE:GetSongBeat(); s:sleep(9e9) end },
	Def.Actor{
		
		OnCommand=function(s)
			s:queuecommand('Update');
		end,
		UpdateCommand=function(s)
			
			if not Globals.checked then
				Globals.P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				Globals.P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				
				Globals.checked = true;
				
				--MESSAGEMAN:Broadcast('GetProxy')
				
				---------------------
				-- grab everything --
				---------------------
				
				local ThingsToGrab = {'BPMDisplay','LifeFrame','ScoreFrame','Overlay','Underlay','StageDisplay','SongTitle'}

				Globals.mod_plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				Globals.mod_plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2');

				for i,v in pairs(Globals.mod_plr) do
					table.insert(ThingsToGrab,'LifeP'..i); table.insert(ThingsToGrab,'ScoreP'..i);
					table.insert(ThingsToGrab, 'SongMeterDisplayP'..i)
					table.insert(ThingsToGrab, 'StepsDisplayP'..i)
					table.insert(ThingsToGrab, 'LifeMeterBarP'..i)
					Globals['P'..i]:vibrate()
					Globals['P'..i]:effectmagnitude(0,0,0)
				end
				
			end
			
			local beat = GAMESTATE:GetSongBeat();
			
			for i,v in pairs(Globals.mod_plr) do
				Globals['P'..i]:effectmagnitude(wida_aux_player:GetX(),wida_aux_player:GetY(),wida_aux_player:GetZ())
			end
			for i=1,3 do
				_G['wida_layer'..i]:effectmagnitude(wida_aux_aft:GetX(),wida_aux_aft:GetY(),wida_aux_aft:GetZ())
				
			end
			
			
			---------------------------------------
			-- Actions table --
			---------------------------------------
			if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
				while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
					if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
						if type(mod_actions[curaction][2]) == 'function' then
							mod_actions[curaction][2]()
						elseif type(mod_actions[curaction][2]) == 'string' then
							MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
						end
					end
					curaction = curaction+1;
				end
			end
			
			s:sleep(1/60);
			s:queuecommand('Update');
			
		end,
	
	},
	wida_screenaft,
	Def.Quad{
		OnCommand=cmd(diffuse,0,0,0,1;stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT)
	},
	Def.Sprite{
		InitCommand=function(self) wida_layer1 = self end,
		ProxyStartMessageCommand= function(self)
			self:vibrate()
			self:effectmagnitude(0,0,0)
			self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
			self:rotationz(0);
			self:diffuse(1,0,0,1)
			self:blend('add')
			if d3d then
				self:visible(false)
			else
				self:SetTexture(screenAft:GetTexture())
			end
		end,
	},
	Def.Sprite{
		InitCommand=function(self) wida_layer2 = self end,
		ProxyStartMessageCommand= function(self)
			self:vibrate()
			self:effectmagnitude(0,0,0)
			self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
			self:rotationz(0);
			self:diffuse(0,1,0,1)
			self:blend('add')
			if d3d then
				self:visible(false)
			else
				self:SetTexture(screenAft:GetTexture())
			end
		end,
	},
	Def.Sprite{
		InitCommand=function(self) wida_layer3 = self end,
		ProxyStartMessageCommand= function(self)
			self:vibrate()
			self:effectmagnitude(0,0,0)
			self:xy(SCREEN_CENTER_X,SCREEN_CENTER_Y)
			self:rotationz(0);
			self:diffuse(0,0,1,1)
			self:blend('add')
			if d3d then
				self:visible(false)
			else
				self:SetTexture(screenAft:GetTexture())
			end
		end,
	},
	
	Def.Actor{
		InitCommand=function(self) wida_aux_aft = self end,
		ShakeScreenMessageCommand=function(self)
			self:finishtweening()
			self:xy(30,30)
			self:decelerate(60/126)
			self:xy(0,0)
		end,
		ShakeScreenLong1MessageCommand=function(self)
			self:finishtweening()
			self:xy(10,0)
			self:linear(120/126)
			self:xy(0,0)
			self:sleep(0)
			self:xy(10,0)
			self:linear(120/126)
			self:xy(0,0)
		end,
		ShakeScreenLong2MessageCommand=function(self)
			self:finishtweening()
			self:xy(10,0)
			self:linear(90/126)
			self:xy(0,0)
			self:sleep(0)
			self:xy(0,10)
			self:linear(30/126)
			self:xy(0,0)
			self:sleep(0)
			self:xy(10,0)
			self:linear(60/126)
			self:xy(0,0)
		end,
		ShakeScreenLong3MessageCommand=function(self)
			self:finishtweening()
			self:xy(10,0)
			self:linear(120/126)
			self:xy(0,0)
			self:sleep(0)
			self:xy(10,0)
			self:linear(60/126)
			self:xy(0,0)
		end,
	},
	Def.Actor{
		InitCommand=function(self) wida_aux_player = self end,
		ShakeScreenMessageCommand=function(self)
			self:finishtweening()
			self:xy(30,30)
			self:decelerate(60/126)
			self:xy(0,0)
		end,
		BumpLeft=function(self)
			self:finishtweening()
			self:xy(30,30)
			self:decelerate(30/126)
			self:xy(0,0)
		end,
		BumpRight=function(self)
			self:finishtweening()
			self:xy(30,30)
			self:decelerate(30/126)
			self:xy(0,0)
		end,
		ShakePlayersShortMessageCommand=function(self)
			self:finishtweening()
			self:xy(30,30)
			self:decelerate(30/126)
			self:xy(0,0)
		end
	},
	Def.Actor{
		WewMessageCommand=function()
			for pn=1,2 do
				local a = Plr(pn)
				if a then
					a:skewx(1)
					a:decelerate(60/126)
					a:skewx(0)
				end
			end
		end,
		BumpLeftMessageCommand=function()
			for pn=1,2 do
				local a = Plr(pn)
				if a then
					a:zoomx(1.5)
					a:decelerate(60/126)
					a:skewx(0)
					a:zoomx(1)
				end
			end
		end,
		BumpRightMessageCommand=function()
			for pn=1,2 do
				local a = Plr(pn)
				if a then
					a:zoomx(1.5)
					a:decelerate(60/126)
					a:skewx(0)
					a:zoomx(1)
				end
			end
		end,
	},
	
}