local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'),GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
local songDir = GAMESTATE:GetCurrentSong():GetSongDir()
local pathtolua = 'lua/' -- Edit this to point to the folder the lua files are in.
mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes
local mod_curtime = 0
local mod_lasttime = 0
local mod_globaloffset = PREFSMAN:GetPreference('GlobalOffsetSeconds')
local checked = false
local curaction = 1
local prefix_height_ratio = SCREEN_HEIGHT/480
local prefix_width_ratio = SCREEN_WIDTH/640
local prefix_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640
prefix_globals = {}

-- SHORTCUTS --
local m_bl = 60/126 --use this to define length of a beat for use in the rest of the song
local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT --shortcuts

local function Plr(pn)
	return _G['P'..pn]
end

local flicker = 1

-- EASING --
LoadActor('easing.lua')
LoadActor('modhelpers.lua')	
LoadActor("mods.lua")

-- ALIASES --
--These make it so the syntax for the table entries matches the syntax for the nITG template.
--If you want to prefix all your calls with "modhelpers.", "ease.", etc., then you won't need this and can remove this section.
local linear, inQuad, outQuad, inOutQuad, outInQuad, inCubic, outCubic, inOutCubic, outInCubic, inQuart,outQuart, inOutQuart, outInQuart, inQuint, outQuint, inOutQuint, outInQuint, inSine, outSine, inOutSine,outInSine, inExpo, outExpo, inOutExpo, outInExpo, inCirc, outCirc, inOutCirc, outInCirc, inElastic,outElastic, inOutElastic, outInElastic, inBack, outBack, inOutBack, outInBack, inBounce, outBounce,inOutBounce, outInBounce = ease.linear, ease.inQuad, ease.outQuad, ease.inOutQuad, ease.outInQuad,ease.inCubic, ease.outCubic, ease.inOutCubic, ease.outInCubic, ease.inQuart, ease.outQuart,ease.inOutQuart, ease.outInQuart, ease.inQuint, ease.outQuint, ease.inOutQuint, ease.outInQuint,ease.inSine, ease.outSine, ease.inOutSine, ease.outInSine, ease.inExpo, ease.outExpo, ease.inOutExpo,ease.outInExpo, ease.inCirc, ease.outCirc, ease.inOutCirc, ease.outInCirc, ease.inElastic,ease.outElastic, ease.inOutElastic, ease.outInElastic, ease.inBack, ease.outBack, ease.inOutBack,ease.outInBack, ease.inBounce, ease.outBounce, ease.inOutBounce, ease.outInBounce

local perframe, mod_insert, mod2_insert, mod_ease, mod_perframe, mod_message, mod_blacklist, simple_m0d, simple_m0d2, simple_m0d3, mod_wiggle, mod_spring, mod_springt, mod_springt2, mod_spring_adjustable, mod_beat, switcheroo_add, switcheroo_reset, mod_sugarkiller, modulo, reverseRotation, randomXD, mod_bounce, ease_wiggle, ease_wiggleAbs = modhelpers.perframe, modhelpers.mod_insert, modhelpers.mod2_insert, modhelpers.mod_ease, modhelpers.mod_perframe, modhelpers.mod_message, modhelpers.mod_blacklist, modhelpers.simple_m0d, modhelpers.simple_m0d2, modhelpers.simple_m0d3, modhelpers.mod_wiggle, modhelpers.mod_spring, modhelpers.mod_springt, modhelpers.mod_springt2, modhelpers.mod_spring_adjustable, modhelpers.mod_beat, modhelpers.switcheroo_add, modhelpers.switcheroo_reset, modhelpers.mod_sugarkiller, modhelpers.modulo,modhelpers.reverseRotation, modhelpers.randomXD, modhelpers.mod_bounce, modhelpers.ease_wiggle, modhelpers.ease_wiggleAbs

---------------------------------------------------------
---------DOCUMENTATION-----------------------------------
---------------------------------------------------------

--function perframe( beat, endBeat )
	--return true if the current beat is between 'beat' and 'endBeat'

--function mod_shader(beat,key,which)
	--turn on shader key at specified beat (up to 10 keys available, defined by 'which' = 0-9
	
--function mod_insert(beat,len,mod,len_or_end,pn)
	--insert mod into beat mods table
--function mod_insert2(time,len,mod,len_or_end,pn)
	--insert mod into time mods table
--function mod_ease(beat, len, start_strength, end_strength, mod, len_or_end, ease_type, pn, sustain, opt1, opt2)
	--insert mod into ease mods table
--function mod_perframe(start, end, function(beat, deltatime))
	--insert function into perframe reader
	
--function mod_message(beat,msg,persistent)
	--insert something into the actions table.
	--msg can also be a function. If string, a message gets broadcast at that beat
	--if 'persistent' is true, message will run even if editor starts at a beat past it
	
--function mod_blacklist(t,n)
	--check if number n occurs in table t
	--useful for doing 'every beat EXCEPT the contents of t'
	
--function simple_m0d(beat,strength,mult,mod)
--function simple_m0d2(beat,strength,mult,mod,pn)
--function simple_m0d3(beat,strength,duration,bpm,mod,pn)
	--activate mods at specific beat but also deactivate them
	
--function mod_wiggle(beat,num,div,amt,speed,mod,pn,first)
	--alternates a mod back and forth before resetting to 0
	
--function mod_spring(beat,strength,num,mod,pn)
	--like mod_wiggle, but springier

--function mod_springt(time,strength,dur,mod,pn)
	--time-based per-frame alternating mod that decreases based on how much time is left.
		--think doorstopper

--function mod_springt2(time,strength,dur,mod,pn)
	--time-based per-frame alternating mod

--function mod_spring_adjustable(beat,strength,num,period,mod,pn, first)
	--it's not very good

--function mod_beat(beat,strength,pn)
	--turns on beat for the beat specified, at the desired strength	

--function switcheroo_add(beat,which,speed,len,pn)
	--adds a column swap at the desired beat
--[[	switcheroos = {normal = {0,0}, ldur = {0,0}, reset = {0,0},
		flip = {100,0}, rudl = {100,0}, invert = {0,100}, dlru = {0,100},
		ludr = {25,-75}, rdul = {75,75}, drlu = {25,125}, ulrd = {75,-125}, urld = {100,-100}}
]]

--function mod_sugarkiller(beat,duration,speed,minstealth,maxstealth,pn)
	--portable version of the effect from sugarkill X

--function mod_bounce(beat,length,start,apex,mod,ease_type,pn)
	--eases out from start to apex, then eases back in from apex to start
	--ease_type should be a string, i.e. outQuad, inQuad, 'Cubic', outCirc, inCirc



--function modulo(a, b)
	--returns the remainder when a is divided by b, works properly with negatives unlike math.mod

--function randomXD(t)
	--returns a pseudo-random number between 0 and 1 seeded based on the given argument
	--returns 0.5 if t is 0 (useful sometimes!)
	
---------------------------------------------------------
--------END DOCUMENTATION--------------------------------
---------------------------------------------------------

local function mod_do(str,pn)
	if pn then
		--GAMESTATE:ApplyGameCommand('mod,'..str,pn)
		taronuke_mods(str,pn);
	else
		--GAMESTATE:ApplyGameCommand('mod,'..str)
		for pn=1,2 do
			taronuke_mods(str,pn);
		end
	end
end
			
-- PLAYERS & JUDCOM PROXIES --
--Holds the Player actors, NoteField actors and NoteField wrapper states, if you need them.
local mod_plr = {nil,nil}
local mod_nfd = {nil,nil}
local mod_nfdwrap = {nil,nil}

-- TABLES --
--This is where the mods are stored! There's multiple tables, so look at each one.

--beat based mods
--{beat_start, beat_end, mods, len_or_end, player_number}
prefix_globals.mods = {
	{0,9999,'*99999 3.5x, *99999 m441, *99999 overhead','end'},
}

--beat-based ease mods
--{beat_start, beat_end, mod_start, mod_end, mod/function, len_or_end, ease_type, player_number, sustainbeats, optional_param1, optional_param2}
--valid ease types are:
	--linear
	--inQuad    outQuad    inOutQuad    outInQuad
	--inCubic   outCubic   inOutCubic   outInCubic
	--inQuart   outQuart   inOutQuart   outInQuart
	--inQuint   outQuint   inOutQuint   outInQuint
	--inSine    outSine    inOutSine    outInSine
	--inExpo    outExpo    inOutExpo    outInExpo
	--inCirc    outCirc    inOutCirc    outInCirc
	--inElastic outElastic inOutElastic outInElastic    --can take 2 optional parameters - amplitude & period
	--inBack    outBack    inOutBack    outInBack       --can take 1 optional parameter  - spring amount
	--inBounce  outBounce  inOutBounce  outInBounce
	
prefix_globals.ease = {
	-- EXAMPLE TWEEN: from beat 0 to 4, make drunk go from 360 to 0 with the inOutBack tween
	--{0, 4, 360, 0, 'drunk', 'len', inOutBack},
	
	-- EXAMPLE TWEEN: from beat 4 to 8, rotate topscreen from 360 to 0 with the outBack tween
	--{4, 4, 360, 0, function(a) SCREENMAN:GetTopScreen():rotationz(a) end, 'len', outBack},
}

--mod_ease(4, 16, -300, 0, 'drunk', 'len', outQuad)

--time based mods
--{time_start, time_end, mods, len_or_end, player_number}
prefix_globals.mods2 = {
}

-- you can now write perframe stuff without having to scroll down!
-- {beat_start,beat_end,function(beat,deltatime)}
prefix_globals.perframes = {
	--{18,24,function(beat,deltatime)
		-- do stuff every frame from beat 18-24
		-- print(beat,deltatime)
	--end},
}

--this is both a message broadcaster and a function runner
--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
--if you put {beat,function() somecode end}, then function() is run at that beat
--see example on beat 0

--{beat,thing,persists}
prefix_globals.actions = {
	{0,'GetProxy',true},
	{0,function()
		for pn=1,2 do
			local a = Plr(pn)
			if a then
				a:fardistz(10000*prefix_width_ratio):rotafterzoom(false)
				mod_nfdwrap[pn]:rotafterzoom(false):zoomz(prefix_sdwidth_ratio)
			end
		end
	end,true},
}				

-- STARTING MODS --
--Set the initial mods that get applied after a clearall.
local init_modsp = {'',''}

-- UPDATE FUNCTION --
--This is where the readers are run.
local disable = false;
local function DoUpdate()
	local beat = GAMESTATE:GetSongBeat()

	mod_curtime = GAMESTATE:GetCurMusicSeconds() + mod_globaloffset
	local deltatime = mod_curtime - mod_lasttime
	mod_lasttime = mod_curtime

---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------

	if disable ~= true and checked then
		if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
			-----------------------
			-- Player mod resets --
			-----------------------
			for i=1,2 do
				mod_do('clearall',i)
			end

			------------------------------------------------------------------------------
			-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
			------------------------------------------------------------------------------
			for i,v in pairs(prefix_globals.mods) do
				if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
					if beat >=v[1] then
						if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
							if table.getn(v) == 5 and v[5] then
								mod_do(v[3],v[5]);
							else
								mod_do(v[3]);
							end
						end
					end
				else
					v[1] = 0;
					v[2] = 0;
					v[3] = '';
					v[4] = 'error';
					SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')');
				end
			end
			
			---------------------------------------
			-- Ease table (includes func_ease) --
			---------------------------------------
			for i,v in pairs(prefix_globals.ease) do
				if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
					if beat >=v[1] then
						if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
							local strength = v[7](beat - v[1], v[3], v[4] - v[3], v[6] == 'end' and v[2] - v[1] or v[2], v[10], v[11])
							if type(v[5]) == 'string' then
								local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
								if v[8] then
									mod_do('*9999 '..modstr,v[8]);
								else
									mod_do('*9999 '..modstr);
								end
							elseif type(v[5]) == 'function' then
								v[5](strength)
							end
						elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
							if type(v[5]) == 'string' then
								local modstr = v[5] == 'xmod' and v[4]..'x' or (v[5] == 'cmod' and 'C'..v[4] or v[4]..' '..v[5])
								if v[8] then
									mod_do('*9999 '..modstr,v[8]);
								else
									mod_do('*9999 '..modstr);
								end
							elseif type(v[5]) == 'function' then
								v[5](v[4])
							end
						end
					end
				else
					SCREENMAN:SystemMessage('Ease Error! (line '..i..' | beat: '.. v[1] .. ' | mod: '.. v[5] ..')');
				end
			end

			---------------------
			-- Perframe reader --
			---------------------
			if table.getn(prefix_globals.perframes)>0 then
				for i=1,table.getn(prefix_globals.perframes) do
					local a = prefix_globals.perframes[i]
					if beat > a[1] and beat < a[2] then
						a[3](beat,deltatime);
					end
				end
			end

			---------------------------------------
			-- Actions table --
			---------------------------------------
			while curaction<=table.getn(prefix_globals.actions) and GAMESTATE:GetSongBeat()>=prefix_globals.actions[curaction][1] do
				if prefix_globals.actions[curaction][3] or GAMESTATE:GetSongBeat() < prefix_globals.actions[curaction][1]+2 then
					if type(prefix_globals.actions[curaction][2]) == 'function' then
						prefix_globals.actions[curaction][2]()
					elseif type(prefix_globals.actions[curaction][2]) == 'string' then
						MESSAGEMAN:Broadcast(prefix_globals.actions[curaction][2]);
					end
				end
				curaction = curaction+1;
			end
		end
	end
end

local function hidethings(table)
	for i,v in ipairs(table) do
		if SCREENMAN:GetTopScreen():GetChild(v) then
			SCREENMAN:GetTopScreen():GetChild(v):visible(false)
		end
	end
end
return Def.ActorFrame{
	InitCommand= function(self)
		mod_insert(0, 4, '*9999 dark', 'len')
		mod_ease(4, 16, -200, 0, 'tiny', 'len', outQuad)
		mod_ease(4, 16, -200, 0, 'drunk', 'len', outQuad)
		mod_ease(4, 16, -200, 0, 'tipsy', 'len', outQuad)
		
		mod_ease(20, 2, -200, 0, 'bumpy', 'len', outQuad)
		mod_ease(20, 2, 50, 0, 'stealth', 'len', outQuad)
		
		for i = 0, 29 do
			local mult = (i % 2) * 2 - 1
			mod_ease(4 + i, 1, 25, 0, 'brake', 'len', outQuad)
			mod_ease(3.5 + i, 0.5, 0, 150 * mult, 'drunk', 'len', inCirc)
			mod_ease(4 + i, 0.5, 150 * mult, 0, 'drunk', 'len', outCirc)
		end
		mod_ease(32, 2, -200, 0, 'mini', 'len', outCirc)
		mod_ease(32, 2, 500, 0, 'bumpy', 'len', outCirc)
		mod_ease(32, 2, 50, 0, 'stealth', 'len', outCirc)
		
		mod_ease(34, 2, 0, 200, 'wave', 'len', inBack)
		mod_ease(34, 2, 0, 80, 'roll', 'len', inQuad)
		mod_ease(34, 2, 0, -100, 'mini', 'len', inBack)
		mod_ease(34, 2, 0, -100, 'reverse', 'len', inQuad)
		mod_ease(34, 2, 3.5, 1.5, 'xmod', 'len', inQuad)
		mod_ease(34, 2, 0, 200, 'distant', 'len', outCirc)
		mod_ease(34, 2, 0, -50, 'boost', 'len', outCirc)
		mod_insert(36, 24, '*9999 200 wave, *9999 200 distant, *9999 80 roll, *9999 -100 mini, *9999 -100 reverse, *9999 1.5x, *9999 -50 boost', 'len')
		
		
		--[[mod_message(36, function() for pn = 1, 2 do local a = Plr(pn) if a then
			a:rotationz(10)
		end end end)]]
		
		mod_ease(33, 1, 0, 100, 'invert', 'len', inBack)
		mod_insert(34, 2, '*9999 invert', 'len')
		mod_insert(36, 4, '*9999 no invert, *9999 flip', 'len')
		mod_insert(40, 4, '*9999 75 invert, *9999 75 flip', 'len')
		mod_insert(44, 4, '*9999 -75 invert, *9999 25 flip', 'len')
		mod_insert(48, 4, '*9999 -125 invert, *9999 75 flip', 'len')
		mod_insert(52, 2, '*9999 invert, *9999 no flip', 'len')
		mod_insert(54, 2, '*9999 no invert, *9999 no flip', 'len')
		
		mod_ease(36, 1, 100, 0, 'invert', 'len', outBack)
		mod_ease(36, 1, 0, 100, 'flip', 'len', outBack)
		mod_ease(40, 1, 0, 75, 'invert', 'len', outBack)
		mod_ease(40, 1, 100, 75, 'flip', 'len', outBack)
		mod_ease(44, 1, 75, -75, 'invert', 'len', outBack)
		mod_ease(44, 1, 75, 25, 'flip', 'len', outBack)
		mod_ease(48, 1, -75, -125, 'invert', 'len', outBack)
		mod_ease(48, 1, 25, 75, 'flip', 'len', outBack)
		mod_ease(52, 1, -125, 100, 'invert', 'len', outBack)
		mod_ease(52, 1, 75, 0, 'flip', 'len', outBack)
		mod_ease(54, 1, 100, 0, 'invert', 'len', outBack)
		
		
		mod_ease(52, 8, 200, 0, 'wave', 'len', outQuad)
		mod_ease(52, 8, 200, 0, 'distant', 'len', outQuad)
		mod_ease(52, 8, -50, 0, 'boost', 'len', outQuad)
		mod_ease(52, 8, 80, 0, 'roll', 'len', outQuad)
		mod_ease(52, 8, -100, 0, 'reverse', 'len', outQuad)
		mod_ease(52, 8, 0, 100, 'brake', 'len', outQuad)
		mod_ease(52, 8, 1.5, 3.5, 'xmod', 'len', linear)
		
		function flickFunc(str, mod, offset)
			local flicker = 1
			return function(beat)
				local mag = outQuad(beat % 1, 1, -1, 1) * flicker * str + (offset or 0)
				mod_do('*9999 '..mag..' '..mod);
				flicker = -flicker
			end
		end
		
		for i, v in ipairs({36, 40, 44, 48, 52, 54, 56, 57, 58, 59}) do
			mod_perframe(v, v+1, flickFunc(100, 'mini', -100))
		end
		
		for i = 0, 7 do
			local mult = (i % 2) * 2 - 1
			mod_ease(60 + 0.5 * i, 0.5, 50 + i * 12.5, -100 + i * 12.5, 'mini', 'len', outQuad)
			mod_ease(60 + 0.5 * i, 0.5, 15 * mult * (i+1)/8, 0, function(v) for pn = 1, 2 do local a = Plr(pn) if a then
				a:rotationz(v)
			end end end, 'len', outQuad)
		end
		mod_message(64, function() for pn = 1, 2 do local a = Plr(pn) if a then
			a:rotationz(0)
		end end end)
	
		for i = 0, 7 do
			local mult = (i % 2) * 2 - 1
			local st, nx = i == 0 and 0 or mult * 100, i == 7 and 0 or -mult * 100
			mod_ease(64 + 0.25 * i, 0.25, st, nx, 'drunk', 'len', outCirc)
		end
		mod_ease(64, 1, 0, 100, 'mini', 'len', outCirc)
		mod_ease(65, 3, 100, 0, 'mini', 'len', inExpo)
		mod_bounce(66, 2, 0, 100, 'tipsy', outQuad, inQuad)
		mod_bounce(66, 2, 0, 25, 'flip', outQuad, inQuad)
		
		for j = 0, 3 do
			for i = 0, 1 do
				mod_ease(67 + 4 * i + 16 * j, 1, 0, 100, 'reverse', 'len', inExpo, nil, 1)
				mod_ease(68 + 4 * i + 16 * j, 2, 100, 0, 'tipsy', 'len', outCirc, nil, 1)
				mod_ease(68 + 4 * i + 16 * j, 2, 100, 0, 'brake', 'len', outCirc, nil, 1)
				mod_ease(69 + 4 * i + 16 * j, 1, 100, 0, 'reverse', 'len', inExpo, nil, 1)
				mod_ease(70 + 4 * i + 16 * j, 2, -100, 0, 'tipsy', 'len', outCirc, nil, 1)
				mod_ease(70 + 4 * i + 16 * j, 2, 100, 0, 'brake', 'len', outCirc, nil, 1)
				
				for k = 0, 1 do
					local boof = 68 + 2 * k + 4 * i + 16 * j
					mod_perframe(boof, boof + 1, flickFunc(100, 'mini'))
				end
				
				for k = 0, 3 do
					local mult = (i % 2) * 2 - 1
					mod_ease(67.5 + 4 * i + 16 * j + k, 0.5, 0, 150 * mult, 'drunk', 'len', inCirc)
					mod_ease(68 + 4 * i + 16 * j + k, 0.5, 150 * mult, 0, 'drunk', 'len', outCirc)
				end
			end
			
			if j ~= 3 then
				local lim = j == 1 and 5 or (j == 2 and 6 or 7)
				for i = 0, lim do
					local mult = (i % 2) * 2 - 1
					
					if 76 + 16 * j + i ~= 111 then
						mod_bounce(76 + 16 * j + i, 1, 0, -40, 'centered', outQuad, inQuad)
						mod_bounce(76 + 16 * j + i, 1, 0, 20 * mult, 'tipsy', outCirc, inCirc)
						mod_bounce(76 + 16 * j + i, 1, 0, 30 * mult, 'tornado', outCirc, inCirc)
					end
				end
				
				mod_perframe(76 + 16 * j, 77 + lim + 16 * j, function(beat)
					for pn = 1, 2 do
						mod_do('*9999 '.. math.sin(beat * math.pi) * 30 ..' dizzy', pn);
						mod_do('*9999 '.. math.sin(beat * math.pi) * 15 ..' invert', pn);
						local a = Plr(pn) if a then
							a:rotationy(math.sin(beat * math.pi) * 15)
						end
					end
				end)
			end
		end
		
		for i = 0, 5 do
			local mult = (i%2)*2-1
			mod_ease(81 + 0.333 * i, 0.333, 20, 0, 'brake', 'len', outQuad)
			mod_ease(81 + 0.333 * i, 0.333, 50, 0, 'stealth', 'len', outQuad)
		end
		
		mod_ease(90.5, 0.5, 50, 0, 'stealth', 'len', linear)
		mod_ease(91, 0.5, 50, 0, 'stealth', 'len', linear)
		mod_ease(91.5, 0.5, 50, 0, 'stealth', 'len', linear)
		
		mod_ease(98, 1, 0, 100, 'mini', 'len', outCirc)
		mod_ease(99, 1, 100, 0, 'mini', 'len', inCirc)
		mod_ease(98, 1, 0, 50, 'brake', 'len', outCirc)
		mod_ease(99, 1, 50, 0, 'brake', 'len', inCirc)
		mod_bounce(99, 1, 0, 60, 'tipsy', outQuad, inQuad)
		mod_bounce(99, 1, 0, 25, 'flip', outQuad, inQuad)
		
		mod_bounce(111, 1, 0, 25, 'reverse', outQuad, inQuad)
		
		mod_bounce(115, 1, 0, 314, 'dizzy', outQuad, inQuad)
		mod_bounce(115, 1, 0, 50, 'brake', outQuad, inQuad)
		for i = 0, 11 do
			local mult = (i % 2) * 2 - 1
			if i < 8 then
				mod_ease(116 + i, 1, 50, 0, 'stealth', 'len', linear)
			end
			mod_ease(116 + i, 1, -600 * mult, 0, 'bumpy', 'len', outQuad)
		end
		
		mod_ease(124, 4, 0, -100, 'hallway', 'len', linear)
		mod_ease(124, 4, 0, -50, 'flip', 'len', linear)
		mod_ease(124, 4, 0, -314, 'dizzy', 'len', linear)
		mod_ease(128, 2, -100, 0, 'hallway', 'len', outQuad)
		mod_ease(128, 2, -50, 0, 'flip', 'len', outQuad)
		mod_ease(128, 2, -314, 0, 'dizzy', 'len', outQuad)
		
		mod_ease(128, 2, 3.5, 1, 'xmod', 'len', outQuad)
		mod_ease(128, 2, 0, -600, 'bumpy', 'len', outQuad)
		mod_ease(130, 2, -600, 0, 'bumpy', 'len', inQuad)
		mod_ease(130, 2, 1, 2.5, 'xmod', 'len', inQuad)
		mod_insert(132, 16, '*9999 2.5x', 'len')
		
		mod_ease(130, 1, -200, 0, 'tornado', 'len', outCirc)
		
		for i = 0, 14 do
			local mult = (i % 2) * 2 - 1
			mod_ease(132 + i, 0.5, 0, 15 * mult, function(v) for pn = 1, 2 do local a = Plr(pn) if a then
				a:rotationy(v)
			end end end, 'len', outQuad)
			mod_ease(132.5 + i, 0.5, 15 * mult, 0, function(v) for pn = 1, 2 do local a = Plr(pn) if a then
				a:rotationy(v)
			end end end, 'len', inQuad, nil, 1)
		end
		
		for i = 0, 2 do
			mod_ease(135 + 4 * i, 2, -800, 0, 'bumpy', 'len', outCirc)
			mod_ease(135 + 4 * i, 2, -50, 0, 'mini', 'len', outCirc)
			mod_ease(135 + 4 * i, 2, 50, 0, 'stealth', 'len', outCirc)
		end
		
		mod_perframe(132, 135, function(beat)
			beat = math.floor(beat) + outBack(beat % 1, 0, 1, 1)
			local angle = beat * math.pi * 2/3
			local alt, rev, inv = math.sin(angle) * 20, math.sin(angle) * -10, -math.cos(angle) * 50 + 50
			mod_do('*9999 '..alt..' alternate, *9999 '..rev..' reverse, *9999 '..inv..' invert')
		end)
		
		mod_perframe(136, 139, function(beat)
			beat = math.floor(beat) + outBack(beat % 1, 0, 1, 1)
			local angle = (beat - 4) * math.pi * 2/3
			local alt, rev, inv = math.sin(angle) * -20, math.sin(angle) * 10, -math.cos(angle) * 50 + 50
			mod_do('*9999 '..alt..' alternate, *9999 '..rev..' reverse, *9999 '..inv..' invert')
		end)
		
		mod_perframe(140, 143, function(beat)
			beat = math.floor(beat - 8) + outBack(beat % 1, 0, 1, 1)
			local angle = beat * math.pi * 2/3
			local crs, rev, inv = math.sin(angle) * 20, math.sin(angle) * -10, -math.cos(angle) * 50 + 50
			mod_do('*9999 '..crs..' cross, *9999 '..rev..' reverse, *9999 '..inv..' invert')
		end)
		mod_perframe(144, 147, function(beat)
			beat = math.floor(beat - 12) + outBack(beat % 1, 0, 1, 1)
			local angle = beat * math.pi * 2/3
			local crs, rev, inv = math.sin(angle) * -20, math.sin(angle) * 10, -math.cos(angle) * 50 + 50
			mod_do('*9999 '..crs..' cross, *9999 '..rev..' reverse, *9999 '..inv..' invert')
		end)
		
		mod_ease(146, 1, -400, 0, 'mini', 'len', outCirc)
		mod_ease(146, 1, 50, 0, 'flip', 'len', outCirc)
		mod_ease(147, 1, 0, 200, 'distant', 'len', outCirc)
		mod_ease(147, 1, 0, -50, 'reverse', 'len', outCirc)
		mod_ease(147, 1, 0, 20, 'roll', 'len', outCirc)
		mod_insert(148, 8, '*9999 200 distant, *9999 -50 reverse, *9999 20 roll, *9999 2.5x', 'len')
		
		for i, v in ipairs({148, 150, 152, 153, 154, 155}) do
			mod_ease(v, 2, 100, 0, 'brake', 'len', outQuad)
			mod_ease(v, 2, -100, 0, 'mini', 'len', outQuad)
		end
		
		mod_ease(156, 4, 200, 0, 'distant', 'len', inQuad)
		mod_ease(156, 4, -50, 0, 'reverse', 'len', inQuad)
		mod_ease(156, 4, 20, 0, 'roll', 'len', inQuad)
		mod_ease(156, 4, 2.5, 1.8, 'xmod', 'len', inQuad)
		mod_ease(156, 4, -25, -50, 'mini', 'len', inQuad)
		mod_ease(160, 1, -50, 0, 'mini', 'len', outQuad)
		mod_ease(156, 4, 0, -300, 'bumpy', 'len', inQuad)
		mod_ease(160, 1, -300, 0, 'bumpy', 'len', outQuad)
		
		mod_insert(160, 4, '*9999 1.8x, *9999 25 suddenoffset', 'len')
		
		for i = 0, 2 do
			local mult = (i%2)*2-1
			--mod_ease(160 + i, 1, 314 * mult, 0, 'dizzy', 'len', outQuad)
			mod_ease(160 + i, 1, 50, 0, 'brake', 'len', inQuad)
			mod_ease(160 + i, 1, 50 * mult, 0, 'tipsy', 'len', inQuad)
			--mod_ease(160 + i, 1, 0, 95, 'centered', 'len', linear)
		end
		local fuckfactor = 95 * 4 * 1.8/2
		mod_ease(160, 3, 0, -fuckfactor * 0.45, 'centered', 'len', inQuad)
		mod_ease(163, 1, 0, 100, 'mini', 'len', inSine)
		mod_ease(163, 1, 0, 100, 'sudden', 'len', outQuad)
		mod_insert(164, 64, '*9999 1.8x, *9999 mini, *9999 sudden, *9999 25 suddenoffset', 'len')
		mod_insert(196, 32, '*9999 100 suddenoffset', 'len')
		for i = 0, 3 do
			mod_insert(16 * i + 163, 8, '*9999 no reverse')
			mod_ease(16 * i + 163, 1, 100, 0, 'stealth', 'len', outCirc)
			mod_ease(16 * i + 163, 1, 100, 0, 'dark', 'len', outCirc)
			mod_ease(16 * i + 163, 8, -fuckfactor * 0.4, fuckfactor * 0.6, 'centered', 'len', linear)
			mod_ease(16 * i + 170, 1, 0, 100, 'stealth', 'len', inQuad)
			mod_ease(16 * i + 170, 1, 0, 100, 'dark', 'len', inQuad)
			mod_insert(16 * i + 171, 8, '*9999 reverse', 'len')
			mod_ease(16 * i + 171, 1, 100, 0, 'stealth', 'len', outCirc)
			mod_ease(16 * i + 171, 1, 100, 0, 'dark', 'len', outCirc)
			mod_ease(16 * i + 171, 8, -fuckfactor * 0.35, fuckfactor * 0.65, 'centered', 'len', linear)
			mod_ease(16 * i + 178, 1, 0, 100, 'stealth', 'len', inQuad)
			mod_ease(16 * i + 178, 1, 0, 100, 'dark', 'len', inQuad)
		end
		
		for i = 0, 2 do
			local mult = (i % 2) * 2 - 1
			mod_ease(193 + i, 1, 50, 100, 'mini', 'len', outQuad)
			mod_ease(193 + i, 1, 500 * mult, 0, 'bumpy', 'len', outQuad)
			mod_ease(193 + i, 1, 314 * mult, 0, 'dizzy', 'len', outQuad)
		end
		
		local kicks = {196, 199, 200.5, 201, 204, 207, 209}
		for i, v in ipairs(kicks) do
			for j= 0, 1 do
				mod_ease(v + 16 * j, 2, 0, 100, 'mini', 'len', outCirc)
			end
		end
		
		for i = 0, 7 do
			local mult = (i % 2) * 2 - 1
			mod_ease(198 + 4 * i, 2, 1000 * mult, 0, 'bumpy', 'len', outCirc)
		end
		mod_insert(195, 32, '*9999 -50 drunk', 'len')
		
		mod_insert(227, 4, '*9999 no mini, *9999 no sudden, *9999 no hidden, *9999 no reverse, *9999 3x, *2 no stealth, *2 no dark, *9999 no centered', 'len')
		--mod_ease(227, 2, -fuckfactor * 0.45 * 0.5, 0, 'centered', 'len', outCirc)
		mod_insert(227, 64, '*9999 3x', 'len')
		
		local scar = {
			{0, 0, 0, 0},
			{-50, -50, -50, 100},
			{-100, 0, 0, 100},
			{-50, 50, -50, 100},
			{0, 0, 0, 100},
			{50, 50, 50, 0},
			{100, 0, 0, 0},
			{50, -50, 50, 0}
		}
		
		for i = 0, 31 do
			local mult = (i%2)*2-1
			mod_ease(228.5 + i, 0.5, 0, 70 * mult, 'drunk', 'len', inCirc)
			mod_ease(229 + i, 0.5, 70 * mult, 0, 'drunk', 'len', outCirc)
			mod_ease(228 + i, 1, 50, 0, 'brake', 'len', outCirc)
			--[[local t, n = scar[i%8+1], scar[(i+1)%8+1]
			mod_ease(228 + i, 1, t[1], n[1], 'split', 'len', outCirc)
			mod_ease(228 + i, 1, t[2], n[2], 'cross', 'len', outCirc)
			mod_ease(228 + i, 1, t[3], n[3], 'alternate', 'len', outCirc)
			mod_ease(228 + i, 1, t[4], n[4], 'reverse', 'len', outCirc)]]
		end
		
		for i = 0, 7 do
			mod_ease(230.75 + 4 * i, 0.75, -150, 0, 'tipsy', 'len', outQuad)
			mod_ease(231.5 + 4 * i, 2, 150, 0, 'tipsy', 'len', outQuad)
		end
		
		mod_ease(228, 32, 2, 0.5, 'xmod', 'len', inQuad, nil, 999)
		mod_ease(228, 32, 0, 200, 'mini', 'len', inQuad, nil, 999)
		mod_ease(228, 32, 0, 50, 'flip', 'len', inQuad, nil, 999)
		mod_ease(228, 32, 0, 100, 'dark', 'len', inCirc, nil, 999)
		mod_ease(252, 8, 0, 800, 'drunk', 'len', inCirc, nil, 999)
---------------------------------------------------------------------------------------
----------------------Sort the actions table-------------------------------------------
---------------------------------------------------------------------------------------

		local function modtable_compare(a,b)
			return a[1] < b[1]
		end

		if table.getn(prefix_globals.actions) > 1 then
			table.sort(prefix_globals.actions, modtable_compare)
		end
	end,
	Def.Actor{OnCommand=function(s) s:sleep(9e9) end},
	Def.ActorFrame{
		OnCommand= function(self)
			self:queuecommand('BeginUpdate')
		end,
		BeginUpdateCommand= function(self)
			local beat = GAMESTATE:GetSongBeat()
			if beat>=0 and not checked then
				local ThingsToGrab = {'Lyrics','SongBackground','SongForeground'}
				local ThingsToHide = {'BPMDisplay','LifeFrame','ScoreFrame','Overlay','Underlay','StageDisplay','SongTitle'}
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil;
					if _G['P'..pn] then
						mod_plr[pn] = _G['P'..pn]
						mod_nfd[pn] = _G['P'..pn]:GetChild('NoteField')
						if _G['P'..pn]:GetChild('NoteField'):GetNumWrapperStates() == 0 then
							_G['P'..pn]:GetChild('NoteField'):AddWrapperState()
						end
						mod_nfdwrap[pn] = _G['P'..pn]:GetChild('NoteField'):GetWrapperState(1)
					end
					table.insert(ThingsToHide,'LifeP'..pn); table.insert(ThingsToHide,'ScoreP'..pn);
					table.insert(ThingsToHide, 'SongMeterDisplayP'..pn)
					table.insert(ThingsToHide, 'StepsDisplayP'..pn)
					table.insert(ThingsToHide, 'LifeMeterBarP'..pn)
				end
				for i,v in ipairs(ThingsToGrab) do _G[v] = SCREENMAN:GetTopScreen():GetChild(v) or nil end
				--hidethings(ThingsToHide)
				checked = true;
			end
			if checked then self:SetUpdateFunction(DoUpdate)
			else self:sleep(0.02):queuecommand('BeginUpdate') end
		end,
	},
	--Put your actors here!
	
}
